/* HID macro-keyboard */
/* PIC16f1455  */
/* Without crystal resonator */
/* 14key version */

/*#define	uskey */	/* use usa type keyboard */
#define jpkey  	/* use OADG type keyboard */

/**	INCLUDES *******************************************************/
#include <xc.h>
#include "usb.h"
#include "HardwareProfile.h"
#include "usb_function_hid.h"
/**	CONFIGURATION **************************************************/
//defined(LOW_PIN_COUNT_USB_DEVELOPMENT_KIT)
#pragma	config FCMEN	= OFF
#pragma	config IESO		= OFF
#pragma	config CLKOUTEN	= OFF
#pragma	config BOREN	= OFF
#pragma	config CP		= OFF
#pragma	config MCLRE	= OFF
#pragma	config PWRTE	= ON
#pragma	config WDTE		= OFF
#pragma	config FOSC		= INTOSC
#pragma	config LVP		= ON
#pragma	config BORV		= 1
#pragma	config STVREN	= ON
#pragma	config PLLEN	= 1
#pragma	config PLLMULT	= 1
#pragma	config USBLSCLK	= 1
#pragma	config CPUDIV	= 0
#pragma	config WRT		= OFF

/**	VARIABLES ******************************************************/

#define	IN_DATA_BUFFER_ADDRESS 0x2050
#define	OUT_DATA_BUFFER_ADDRESS	0x20A0
#define	IN_DATA_BUFFER_ADDRESS_TAG @IN_DATA_BUFFER_ADDRESS
#define	OUT_DATA_BUFFER_ADDRESS_TAG	@OUT_DATA_BUFFER_ADDRESS

unsigned char hid_report_in[HID_INT_IN_EP_SIZE]	IN_DATA_BUFFER_ADDRESS_TAG;
volatile unsigned char hid_report_out[HID_INT_OUT_EP_SIZE] OUT_DATA_BUFFER_ADDRESS_TAG;

USB_HANDLE lastINTransmission;
USB_HANDLE lastOUTTransmission;
/**	PRIVATE	PROTOTYPES *********************************************/
BOOL Switch1IsPressed(void);
BOOL Switch2IsPressed(void);
BOOL Switch3IsPressed(void);
BOOL Switch4IsPressed(void);
BOOL Switch5IsPressed(void);
BOOL Switch6IsPressed(void);
BOOL Switch7IsPressed(void);
BOOL Switch8IsPressed(void);
BOOL Switch9IsPressed(void);
BOOL Switch10IsPressed(void);
BOOL Switch11IsPressed(void);
BOOL Switch12IsPressed(void);
BOOL Switch13IsPressed(void);
BOOL Switch14IsPressed(void);

BOOL old_sw1,old_sw2,old_sw3,old_sw4,old_sw5,old_sw6,old_sw7,old_sw8;
BOOL old_sw9,old_sw10,old_sw11,old_sw12,old_sw13,old_sw14;
BOOL sw1,sw2,sw3,sw4,sw5,sw6,sw7,sw8;
BOOL sw9,sw10,sw11,sw12,sw13,sw14;
unsigned char sw_all_off;
static void	InitializeSystem(void);
void ProcessIO(void);
void UserInit(void);
void USBCBSendResume(void);
void USBHIDCBSetReportComplete(void);

void key_code_tx(unsigned char);
void mouse_click_left(void);
void mouse_click_right(void);
void mouse_click(unsigned char);
unsigned char code_conv(unsigned	char);
void s_wait(void);		// delay about 100uSec
void m_wait(void);		// delay about 22mSec
void l_wait(void);		// delay about 699mSec
void key_mouse_tx(int);
unsigned char check_sw(int);
void sw_scan(void);
void set_caps_stat(void);

unsigned char modefire_key = 0;
unsigned char modefire_key_0 = 0;
unsigned char cap;
unsigned char alphabet_flag;
unsigned char caps_stat;


/*---------------------------------------------------------*/
/* macro sequence table */



//rom unsigned char sw1_list[] = "key_1_on\\n" ;
//rom unsigned char sw2_list[] = "key_2_on\\n" ;
//rom unsigned char sw3_list[] = "key_3_on\\n" ;
//rom unsigned char sw4_list[] = "key_4_on\\n" ;
//rom unsigned char sw5_list[] = "key_5_on\\n" ;
//rom unsigned char sw6_list[] = "key_6_on\\n" ;
//rom unsigned char sw7_list[] = "key_7_on\\n" ;
//rom unsigned char sw8_list[] = "key_8_on\\n" ;
//rom unsigned char sw9_list[] = "key_9_on\\n" ;
//rom unsigned char sw10_list[] = "key_10_on\\n" ;
//rom unsigned char sw11_list[] = "key_11_on\\n" ;
//rom unsigned char sw12_list[] = "key_12_on\\n" ;
//rom unsigned char sw13_list[] = "key_13_on\\n" ;
//rom unsigned char sw14_list[] = "key_14_on\\n" ;



//rom unsigned char sw1_list[] = "\\1\\4\\f1" ;	// shift_windows_function1
//rom unsigned char sw2_list[] = "\\1\\4\\f2" ;	// shift_windows_function2
//rom unsigned char sw3_list[] = "\\1\\4\\f3" ;	// shift_windows_function3
//rom unsigned char sw4_list[] = "\\1\\4\\f4" ;	// shift_windows_function4
//rom unsigned char sw5_list[] = "\\1\\4\\f5" ;	// shift_windows_function5
//rom unsigned char sw6_list[] = "\\1\\4\\f6" ;	// shift_windows_function6
//rom unsigned char sw7_list[] = "\\1\\4\\f7" ;	// shift_windows_function7
//rom unsigned char sw8_list[] = "\\1\\4\\f8" ;	// shift_windows_function8
//rom unsigned char sw9_list[] = "\\1\\4\\f9" ;	// shift_windows_function9
//rom unsigned char sw10_list[] = "\\1\\4\\fa" ;	// shift_windows_function10
//rom unsigned char sw11_list[] = "\\1\\4\\fb" ;	// shift_windows_function11
//rom unsigned char sw12_list[] = "\\1\\4\\fc" ;	// shift_windows_function12
//rom unsigned char sw13_list[] = "\\3\\4\\f1" ;	// alt_windows_function1
//rom unsigned char sw14_list[] = "\\3\\4\\f2" ;	// alt_windows_function2

rom const unsigned char sw1_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://digikey.com/jp/ja/digihome.html\"\\n";
rom const unsigned char sw2_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://jp.mouser.com\"\\n";
rom const unsigned char sw3_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://avnetexpress.avnet.com\"\\n";
rom const unsigned char sw4_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://akizukidenshi.com/catalog/c/c/\"\\n";
rom const unsigned char sw5_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://www.sengoku.co.jp/\"\\n";
rom const unsigned char sw6_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://www.marutsu.co.jp/\"\\n";
rom const unsigned char sw7_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://www.chip1stop.com/\"\\n";
rom const unsigned char sw8_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://www.iczoo.com/\"\\n";
rom const unsigned char sw9_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://www.aitendo.com/\"\\n";
rom const unsigned char sw10_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://eleshop.jp/shop/default.aspx/\"\\n";
rom const unsigned char sw11_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://www.microchip.com/\"\\n";
rom const unsigned char sw12_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://www.toeimusen.co.jp/~th/\"\\n";
rom const unsigned char sw13_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://www.oyaide.com/catalog/\"\\n";
rom const unsigned char sw14_list[] = "\\4r\\P\\Prundll32.exe url.dll,FileProtocolHandler \"http://www.patapi.sakura.ne.jp/\"\\n";


/*---------------------------------------------------------*/

/**	VECTOR REMAPPING ***********************************************/
#define	REMAPPED_RESET_VECTOR_ADDRESS 0x00
#define	REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS 0x08
#define	REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS 0x18

int	main(void)
{
	InitializeSystem();

	for(;;)
	{
		USBDeviceTasks();
		ProcessIO();
	}
}


static void	InitializeSystem(void)
{
	UserInit();
}

void UserInit(void)
{

	char n;
	OSCCON = 0xFC;	 //	PLL	enabled, 3x, 16MHz internal	osc, SCS external
	ACTCON = 0x90;	 //	Enable active clock	tuning with	USB

	ANSELA = 0x00;
	ANSELC = 0x03;
	TRISA =	0x00;	/* RA5,RA4 as output */
	TRISC =	0x03;	/* RC0,1 as input */
	PORTA =	0x00;
	PORTC =	0x00;

	old_sw1 = 0; old_sw2 = 0; old_sw3 = 0; old_sw4 = 0; old_sw5 = 0; old_sw6 = 0;
	old_sw7 = 0; old_sw8 = 0; old_sw9 = 0; old_sw10 = 0; old_sw11 = 0; old_sw12 = 0;
	old_sw13 = 0; old_sw14 = 0;


	OPTION_REG = 0x7F;
	for(n = 0 ; n < 4 ; n++){
		for(;;){
			if(ACTCONbits.ACTLOCK == 1)	break;
			USBDeviceInit();
			USBDeviceTasks();
			ACTCONbits.ACTUD = 0;
			ACTCONbits.ACTSRC =	1;
			ACTCONbits.ACTEN = 1;
			l_wait();
			if(ACTCONbits.ACTLOCK == 1)	break;
			UPUEN = 0;
			USBEN = 0;
			ACTCONbits.ACTUD = 1;
			ACTCONbits.ACTSRC =	0;
			ACTCONbits.ACTEN = 0;
			l_wait();
		}
	}


	UPUEN = 0;
	USBEN = 0;
	l_wait();	l_wait();

	lastINTransmission = 0;
	lastOUTTransmission	= 0;
	USBDeviceInit();
}

void sw_scan()
{
	unsigned short h_data,h_data2,h_data3,h_data4,h_data5;

	ANSELC = 0x03;
	TRISC =	0x03;
	ADCON2 = 0x00;

	ADCON1 = 0xe0;	/* right justified , fosc/64* , Vref = VDD */

	sw_all_off = 0x00;

	h_data2 = 0x000;
	h_data3 = 0x000;
	h_data4 = 0x000;
	h_data5 = 0x000;

	for(;;){
		ADCON0 = 0x11;	/* a/d channel = an4 */
		s_wait();
		ADCON0 = 0x13;	/* Start a/d conv */
		s_wait();
		while(ADCON0bits.GO_nDONE);
		s_wait();
		h_data = ADRESH;
		h_data = h_data << 8;
		h_data = h_data | ADRESL; 
		h_data = h_data & 0x3FC;		
		if((h_data == h_data2) && (h_data == h_data5))break;
		h_data5 = h_data4;
		h_data4 = h_data3;
		h_data3 = h_data2;
		h_data2 = h_data;
		s_wait(); 
	}
	sw1 = 0 ; sw2 = 0; sw3 = 0; sw4 = 0; sw5 = 0; sw6 = 0; sw7 = 0; sw_all_off = 0x01;
	sw_all_off = 0x01;

	if(h_data > 0x3b6){}
	else if(h_data > 0x361){ sw1 = 1; sw_all_off = 0x01;}
	else if(h_data > 0x344){ sw2 = 1; sw_all_off = 0x01;}
	else if(h_data > 0x319){ sw3 = 1; sw_all_off = 0x01;}
	else if(h_data > 0x2d5){ sw4 = 1; sw_all_off = 0x01;}
	else if(h_data > 0x255){ sw5 = 1; sw_all_off = 0x01;}
	else if(h_data > 0x100){ sw6 = 1; sw_all_off = 0x01;}
	else                   { sw7 = 1; sw_all_off = 0x01;}


	for(;;){
		ADCON0 = 0x15;	/* a/d channel = an5 */
		s_wait();
		ADCON0 = 0x17;	/* Start a/d conv */
		s_wait();
		while(ADCON0bits.GO_nDONE);
		s_wait();
		h_data = ADRESH;
		h_data = h_data << 8;
		h_data = h_data | ADRESL; 
		h_data = h_data & 0x3FC;		
		if((h_data == h_data2) && (h_data == h_data5))break;
		h_data5 = h_data4;
		h_data4 = h_data3;
		h_data3 = h_data2;
		h_data2 = h_data;
		s_wait(); 
	}

	sw8 = 0 ; sw9 = 0; sw10 = 0; sw11 = 0; sw12 = 0; sw13 = 0; sw14 = 0;

		if(h_data > 0x3b6){}
	else if(h_data > 0x361){ sw8 = 1; sw_all_off = 0x00;}
	else if(h_data > 0x344){ sw9 = 1; sw_all_off = 0x00;}
	else if(h_data > 0x319){ sw10 = 1; sw_all_off = 0x00;}
	else if(h_data > 0x2d5){ sw11 = 1; sw_all_off = 0x00;}
	else if(h_data > 0x255){ sw12 = 1; sw_all_off = 0x00;}
	else if(h_data > 0x100){ sw13 = 1; sw_all_off = 0x00;}
	else                   { sw14 = 1; sw_all_off = 0x00;}

}


void ProcessIO(void)
{	
	if(	sw_all_off == 0x00){
		USBCBSendResume();
	}
	if((USBDeviceState < CONFIGURED_STATE)||(USBSuspendControl==1))	return;

	if(Switch1IsPressed()) key_mouse_tx(1);
	if(Switch2IsPressed()) key_mouse_tx(2);
	if(Switch3IsPressed()) key_mouse_tx(3);
	if(Switch4IsPressed()) key_mouse_tx(4);
	if(Switch5IsPressed()) key_mouse_tx(5);
	if(Switch6IsPressed()) key_mouse_tx(6);
	if(Switch7IsPressed()) key_mouse_tx(7);
	if(Switch8IsPressed()) key_mouse_tx(8);
	if(Switch9IsPressed()) key_mouse_tx(9);
	if(Switch10IsPressed()) key_mouse_tx(10);
	if(Switch11IsPressed()) key_mouse_tx(11);
	if(Switch12IsPressed()) key_mouse_tx(12);
	if(Switch13IsPressed()) key_mouse_tx(13);
	if(Switch14IsPressed()) key_mouse_tx(14);
	s_wait();
}


void key_mouse_tx(int num)
{
	unsigned char b_data;
	unsigned char scan_code;
	rom const unsigned char *list;
	rom const unsigned char *list_0;
	unsigned char c;			/* delay count */
	modefire_key_0 = 0x00;

	set_caps_stat();			// check caps lock status

	
	list = sw1_list;
	if(	num	== 2) list = sw2_list;
	if(	num	== 3) list = sw3_list;
	if(	num	== 4) list = sw4_list;
	if(	num	== 5) list = sw5_list;
	if(	num	== 6) list = sw6_list;
	if(	num	== 7) list = sw7_list;
	if(	num	== 8) list = sw8_list;
	if(	num	== 9) list = sw9_list;
	if(	num	== 10) list = sw10_list;
	if(	num	== 11) list = sw11_list;
	if(	num	== 12) list = sw12_list;
	if(	num	== 13) list = sw13_list;
	if(	num	== 14) list = sw14_list;

	list_0 = list;

	c =	40;
	for(;;){
		modefire_key = 0x00;
		alphabet_flag = 0;
		cap	= 0;
		b_data = *list;
		if(b_data == 0x00){goto	close_key_mouse_tx;}

		if(b_data == 0x5c){			/* \ escape	*/
			list++;
			b_data = *list;
			if(b_data == 0x00){goto	close_key_mouse_tx;}

			if(b_data == 'l'){ USBDeviceTasks(); mouse_click_left(); scan_code =	0x00; goto action; }/* \l */
			if(b_data == 'r'){ USBDeviceTasks(); mouse_click_right(); scan_code = 0x00; goto	action;	}/*	\r */
			#if	defined(jpkey)
			if(b_data == 0x5c){	scan_code = 0x89; goto action; }	/*	\\ */
			#endif
			#if	defined(uskey)
			if(b_data == 0x5c){	scan_code = 0x32; goto action; }	/*	\\ */
			#endif			
			if(b_data == 'n'){	scan_code = 0x28; goto action; }	/* enter \n */
			if(b_data == 'e'){	scan_code = 0x52; goto action; }	/* up arrow	\e */
			if(b_data == 's'){	scan_code = 0x50; goto action; }	/* left	arrow \s */
			if(b_data == 'd'){	scan_code = 0x4f; goto action; }	/* right arrow \d */
			if(b_data == 'x'){	scan_code = 0x51; goto action; }	/* down	arrow \x */
			if(b_data == 't'){	scan_code = 0x2b; goto action; }	/* tab \t */
			if(b_data == 'q'){	scan_code = 0x2a; goto action; }	/* back_space \q */
			if(b_data == 'w'){	scan_code = 0x4c; goto action; }	/* del \w */
			if(b_data == 'z'){	scan_code = 0x29; goto action; }	/* esc \z */
			if(b_data == 'c'){	scan_code = 0x39; goto action; }	/* caps_lock \c	*/
			if(b_data == 'h'){	scan_code = 0x4a; goto action; }	/* home	\h */
			if(b_data == 'i'){	scan_code = 0x49; goto action; }	/* insert \i */
			if(b_data == 't'){	scan_code = 0x4c; goto action; }	/* delete \t */
			if(b_data == 'y'){	scan_code = 0x4d; goto action; }	/* end \y */
			if(b_data == 'u'){	scan_code = 0x4b; goto action; }	/* page_up \u */
			if(b_data == 'o'){	scan_code = 0x4e; goto action; }	/* page_down \o	*/
			if(b_data == 'A'){	scan_code = 0xe1; goto action; }	/* left	shift \A */
			if(b_data == 'B'){	scan_code = 0xe5; goto action; }	/* right shift \B */
			if(b_data == 'C'){	scan_code = 0xe0; goto action; }	/* left	ctrl \C	*/
			if(b_data == 'D'){	scan_code = 0xe4; goto action; }	/* right ctrl \D */
			if(b_data == 'E'){	scan_code = 0xe3; goto action; }	/* left	windows	\E */
			if(b_data == 'F'){	scan_code = 0xe7; goto action; }	/* right windows \F	*/
			if(b_data == 'P'){	m_wait(); scan_code = 0x00; goto	action;	} /* delay \P	*/
			if(b_data == 'p'){	l_wait(); scan_code = 0x00; goto	action;	} /* long delay \p	*/
			if(b_data == 'm'){	for(;;){ if(c == 0x00) break; c	= c	- 1; m_wait(); } scan_code =	0x00; goto action; } /*	rest \t	*/
			if(b_data == '!'){	scan_code = 0x00; if(check_sw(num) == 0){goto close_key_mouse_tx;} list = (list_0 - 1) ;	c =	5 ;	goto action; } /* repeat \! */
			if(b_data == '1'){	scan_code = 0x00; modefire_key_0	= modefire_key_0 | 0x01; goto action; }	/* left	ctrl \1	*/
			if(b_data == '2'){	scan_code = 0x00; modefire_key_0	= modefire_key_0 | 0x02; goto action; }	/* left	shift \2 */
			if(b_data == '3'){	scan_code = 0x00; modefire_key_0	= modefire_key_0 | 0x04; goto action; }	/* left	alt	\3 */
			if(b_data == '4'){	scan_code = 0x00; modefire_key_0	= modefire_key_0 | 0x08; goto action; }	/* left	windows	\4 */
			if(b_data == '5'){	scan_code = 0x00; modefire_key_0	= modefire_key_0 | 0x10; goto action; }	/* right ctrl \5 */
			if(b_data == '6'){	scan_code = 0x00; modefire_key_0	= modefire_key_0 | 0x20; goto action; }	/* right shift \6 */
			if(b_data == '7'){	scan_code = 0x00; modefire_key_0	= modefire_key_0 | 0x30; goto action; }	/* right alt \7	*/
			if(b_data == '8'){	scan_code = 0x00; modefire_key_0	= modefire_key_0 | 0x40; goto action; }	/* right windows \8	*/
			if(b_data == 'f'){	list ++; b_data	= *list;				/* function	key	*/
								if(b_data == 0x00){goto	close_key_mouse_tx;}
								if(b_data == '1'){ scan_code	= 0x3a;	goto action;}
								if(b_data == '2'){ scan_code	= 0x3b;	goto action;}
								if(b_data == '3'){ scan_code	= 0x3c;	goto action;}
								if(b_data == '4'){ scan_code	= 0x3d;	goto action;}
								if(b_data == '5'){ scan_code	= 0x3e;	goto action;}
								if(b_data == '6'){ scan_code	= 0x3f;	goto action;}
								if(b_data == '7'){ scan_code	= 0x40;	goto action;}
								if(b_data == '8'){ scan_code	= 0x41;	goto action;}
								if(b_data == '9'){ scan_code	= 0x42;	goto action;}
								if(b_data == 'a'){ scan_code	= 0x43;	goto action;}
								if(b_data == 'b'){ scan_code	= 0x44;	goto action;}
								if(b_data == 'c'){ scan_code	= 0x45;	goto action;}
								if(b_data == 'd'){ scan_code	= 0x46;	goto action;}	/* prtsc */
								if(b_data == 'e'){ scan_code	= 0x47;	goto action;}	/* scroll lock */
								if(b_data == 'f'){ scan_code	= 0x48;	goto action;}	/* pause break */
							}
			scan_code = 0x00;
		}
		else{
			scan_code = code_conv(b_data);
		}
action:
		USBDeviceTasks(); 
		key_code_tx(scan_code);
		list++;
	}
close_key_mouse_tx:
	return;
}

unsigned char check_sw(int sw)
{
	BOOL sw_stat;
	sw_scan();
	switch (sw)	{
		case 1:	sw_stat	= sw1;
			break;
		case 2:	sw_stat	= sw2;
			break;
		case 3:	sw_stat	= sw3;
			break;
		case 4:	sw_stat	= sw4;
			break;
		case 5:	sw_stat	= sw5;
			break;
		case 6:	sw_stat	= sw6;
			break;
		case 7:	sw_stat	= sw7;
			break;
		case 8:	sw_stat	= sw8;
			break;
		case 9:	sw_stat	= sw9;
			break;
		case 10: sw_stat = sw10;
			break;
		case 11: sw_stat = sw11;
			break;
		case 12: sw_stat = sw12;
			break;
		case 13: sw_stat = sw13;
			break;
		case 14: sw_stat = sw14;
			break;
		default: sw_stat = sw1;
	}

	if(sw_stat == 1){
		 return	TRUE;
		}
	else{
		return FALSE;
	}
}

/* ascii code -> HID key scan code */
#if	defined(uskey)/* us KEYBOARD */
unsigned char code_conv(unsigned	char asc_data) 
{
	alphabet_flag = 0x00;
	if((asc_data > 0x40) &&	(asc_data <	0x5b)){
		alphabet_flag = 0x01;
		cap	= 0x01;
		return(asc_data	- 0x3d);
	}
	if((asc_data > 0x60) &&	(asc_data <	0x7b)){
		alphabet_flag = 0x01;
		cap	= 0x00;
		return(asc_data	- 0x5d);
	}
	if((asc_data > 0x30) &&	(asc_data <	0x3a)){
		return(asc_data	- 0x13);
	}
	if(asc_data	== '0'){
		return(0x27);
	}
	if(asc_data	== '!'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x1E);
	}
	if(asc_data	== '@'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x1F);
	}
	if(asc_data	== '#'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x20);
	}
	if(asc_data	== '$'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x21);
	}
	if(asc_data	== '%'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x22);
	}
	if(asc_data	== '^'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x23);
	}
	if(asc_data	== '&'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x24);
	}
	if(asc_data	== '*'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x25);
	}
	if(asc_data	== '('){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x26);
	}
	if(asc_data	== ')'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x27);
	}
	if(asc_data	== '_'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x2D);
	}
	if(asc_data	== '-'){
		return(0x2D);
	}
	if(asc_data	== '+'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x2E);
	}
	if(asc_data	== '='){
		return(0x2E);
	}
	if(asc_data	== '<'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x36);
	}
	if(asc_data	== '>'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x37);
	}
	if(asc_data	== '?'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x38);
	}
	if(asc_data	== ','){
		return(0x36);
	}
	if(asc_data	== '.'){
		return(0x37);
	}
	if(asc_data	== '/'){
		return(0x38);
	}
	if(asc_data	== ';'){
		return(0x33);
	}
	if(asc_data	== ':'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x33);
	}
	if(asc_data	== 0x22){						/* " */
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x34);
	}
	if(asc_data	== 0x27){						/* ' */
		return(0x34);
	}
	if(asc_data	== '~'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x35);
	}
	if(asc_data	== ']'){
		return(0x30);
	}
	if(asc_data	== '['){
		return(0x2f);
	}
	if(asc_data	== '{'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x2f);
	}
	if(asc_data	== '}'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x30);
	}
	if(asc_data	== '|'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x32);
	}
	if(asc_data	== ' '){
		return(0x2c);
	}
	return(0x00);
}
#endif


#if	defined(jpkey)  /* jp KEYBOARD */
unsigned char code_conv(unsigned char asc_data)
{
	alphabet_flag = 0x00;
	if((asc_data > 0x40) &&	(asc_data <	0x5b)){
		alphabet_flag = 0x01;
		cap	= 0x01;
		return(asc_data	- 0x3d);
	}
	if((asc_data > 0x60) &&	(asc_data <	0x7b)){
		alphabet_flag = 0x01;
		cap	= 0x00;
		return(asc_data	- 0x5d);
	}
	if((asc_data > 0x30) &&	(asc_data <	0x3a)){
		return(asc_data	- 0x13);
	}
	if(asc_data	== '0'){
		return(0x27);
	}
	if(asc_data	== '!'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x1E);
	}
	if(asc_data	== 0x22){						/* " */
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x1F);
	}
	if(asc_data	== '#'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x20);
	}
	if(asc_data	== '$'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x21);
	}
	if(asc_data	== '%'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x22);
	}
	if(asc_data	== '&'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x23);
	}
	if(asc_data	== 0x27){						/* ' */
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x24);
	}
	if(asc_data	== '('){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x25);
	}
	if(asc_data	== ')'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x26);
	}
	if(asc_data	== '-'){
		return(0x2D);
	}
	if(asc_data	== '='){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x2D);
	}
	if(asc_data	== '~'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x2E);
	}
	if(asc_data	== '|'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x89);
	}
	if(asc_data	== '<'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x36);
	}
	if(asc_data	== '>'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x37);
	}
	if(asc_data	== '?'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x38);
	}
	if(asc_data	== ','){
		return(0x36);
	}
	if(asc_data	== '.'){
		return(0x37);
	}
	if(asc_data	== '/'){
		return(0x38);
	}
	if(asc_data	== ';'){
		return(0x33);
	}
	if(asc_data	== ':'){
		return(0x34);
	}
	if(asc_data	== ']'){
		return(0x32);
	}
	if(asc_data	== '['){
		return(0x30);
	}
	if(asc_data	== '{'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x30);
	}
	if(asc_data	== '}'){
		modefire_key = (modefire_key | 0x02);	/* left	shift */
		return(0x32);
	}
	if(asc_data	== ' '){
		return(0x2c);
	}
	return(0x00);
}
#endif


void mouse_click_right()
{
	mouse_click(0x02);
	m_wait();
}

void mouse_click_left()
{
	mouse_click(0x01);
	m_wait();
}

void mouse_click(unsigned char mouse_sw)
{
	if(!HIDRxHandleBusy(lastOUTTransmission)){
		lastOUTTransmission	= HIDRxPacket(HID_EP,(BYTE*)hid_report_out,1);
	} 
	for(;;){
		if(!HIDTxHandleBusy(lastINTransmission))
			break;
	}
	hid_report_in[0] = 0x02;	/* report ID = mouse */
	hid_report_in[1] = mouse_sw;
	hid_report_in[2] = 0;
	hid_report_in[3] = 0;
	lastINTransmission = HIDTxPacket(HID_EP, (BYTE*)hid_report_in, 4);

	for(;;){
		if(!HIDTxHandleBusy(lastINTransmission))
			break;
	}
	hid_report_in[0] = 0x02;	/* report ID = mouse */
	hid_report_in[1] = 0;
	hid_report_in[2] = 0;
	hid_report_in[3] = 0;
	lastINTransmission = HIDTxPacket(HID_EP, (BYTE*)hid_report_in, 4);
}


void key_code_tx(unsigned char scan_code)
{
	if(scan_code	== 0x00) return;

	for(;;){
		if(!HIDTxHandleBusy(lastINTransmission))
			break;
	}

	if(alphabet_flag == 0x01 && modefire_key_0 == 0){	// alphabet key only (without ctrl,alt,shift,win)
		if(caps_stat == 0){
			if(cap == 0x01){
				modefire_key = modefire_key	| 0x02;
			}
			if(cap == 0x00){
				modefire_key = modefire_key	& 0xfd;
			}
		}
		else{
			if(cap == 0x00){
				modefire_key = modefire_key	| 0x02;
			}
			if(cap == 0x01){
				modefire_key = modefire_key	& 0xfd;
			}
		}
	}

	modefire_key = modefire_key	| modefire_key_0;

	hid_report_in[0] = 0x01;	/* report ID = keyboard	*/
	hid_report_in[1] = modefire_key;
	hid_report_in[2] = 0;
	hid_report_in[3] = scan_code;
	hid_report_in[4] = 0;
	hid_report_in[5] = 0;
	hid_report_in[6] = 0;
	hid_report_in[7] = 0;
	hid_report_in[8] = 0;
	lastINTransmission = HIDTxPacket(HID_EP, (BYTE*)hid_report_in, 9);

	for(;;){
		if(!HIDTxHandleBusy(lastINTransmission))
			break;
	}
	hid_report_in[0] = 0x01;	/* report ID = keyboard	*/
	hid_report_in[1] = 0;
	hid_report_in[2] = 0;
	hid_report_in[3] = 0;
	hid_report_in[4] = 0;
	hid_report_in[5] = 0;
	hid_report_in[6] = 0;
	hid_report_in[7] = 0;
	hid_report_in[8] = 0;
	lastINTransmission = HIDTxPacket(HID_EP, (BYTE*)hid_report_in, 9);

	modefire_key_0 = 0x00;
	modefire_key = 0x00;
}

void set_caps_stat()
{
	int n;
	caps_stat = 0;

	for(n = 0 ; n < 2 ; n++){		// send scroll_lock key 2 times
		USBDeviceTasks();
		for(;;){
			if(!HIDTxHandleBusy(lastINTransmission))
				break;
		}
		hid_report_in[0] = 0x01;	/* report ID = keyboard */
		hid_report_in[1] = 0;
		hid_report_in[2] = 0;
		hid_report_in[3] = 0x47;	// scroll lock
		hid_report_in[4] = 0;
		hid_report_in[5] = 0;
		hid_report_in[6] = 0;
		hid_report_in[7] = 0;
		hid_report_in[8] = 0;
		lastINTransmission = HIDTxPacket(HID_EP, (BYTE*)hid_report_in, 9);

		for(;;){
			if(!HIDTxHandleBusy(lastINTransmission))
				break;
		}
		hid_report_in[1] = 0;
		hid_report_in[3] = 0;
		lastINTransmission = HIDTxPacket(HID_EP, (BYTE*)hid_report_in, 9);
	}

	for(n = 0 ; n < 0x08 ; n++){
		USBDeviceTasks();
		for(;;){
			if(!HIDTxHandleBusy(lastINTransmission))
				break;
		}
		hid_report_in[0] = 0x01;	/* report ID = keyboard */
		hid_report_in[1] = 0;
		hid_report_in[2] = 0;
		hid_report_in[3] = 0;
		hid_report_in[4] = 0;
		hid_report_in[5] = 0;
		hid_report_in[6] = 0;
		hid_report_in[7] = 0;
		hid_report_in[8] = 0;
		lastINTransmission = HIDTxPacket(HID_EP, (BYTE*)hid_report_in, 9);

		USBDeviceTasks();
		if(!HIDRxHandleBusy(lastOUTTransmission)){
			if((hid_report_out[0] & 0x02) == 0x02){
				caps_stat = 1;
			}
			lastOUTTransmission	= HIDRxPacket(HID_EP,(BYTE*)&hid_report_out,1);
		} 
	}
}


void s_wait()			// about 100uS
{
	unsigned char n;
	for(n = 0 ; n < 37 ; n++){
		OPTION_REG = 0x00;		// source = FOSC/4 prescaler = 2
		TMR0IF = 0;
		TMR0 = 0xf0;
		for(;;){
			if(TMR0IF == 1) break;		// about 2.67uS delay
		}
	}
}

void m_wait()
{
	unsigned char n;
	for(n = 0 ; n < 4 ; n++){
		OPTION_REG = 0x07;		// source = FOSC/4 prescaler = 256
		TMR0IF = 0;
		TMR0 = 0x00;
		for(;;){
			if(TMR0IF == 1) break;		// about 5.46mS delay
		}
	}
}


void l_wait()
{
	unsigned char n;
	for(n =	0 ;	n <	0x20 ; n++){
		m_wait();
	}
}


BOOL Switch1IsPressed(void)
{
	sw_scan(); 
	if(sw1 != old_sw1){ old_sw1 = sw1; if(sw1 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch2IsPressed(void)
{
	sw_scan(); 
	if(sw2 != old_sw2){ old_sw2 = sw2; if(sw2 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch3IsPressed(void)
{
	sw_scan(); 
	if(sw3 != old_sw3){ old_sw3 = sw3; if(sw3 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch4IsPressed(void)
{
	sw_scan(); 
	if(sw4 != old_sw4){ old_sw4 = sw4; if(sw4 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch5IsPressed(void)
{
	sw_scan(); 
	if(sw5 != old_sw5){ old_sw5 = sw5; if(sw5 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch6IsPressed(void)
{
	sw_scan(); 
	if(sw6 != old_sw6){ old_sw6 = sw6; if(sw6 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch7IsPressed(void)
{
	sw_scan(); 
	if(sw7 != old_sw7){ old_sw7 = sw7; if(sw7 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch8IsPressed(void)
{
	sw_scan(); 
	if(sw8 != old_sw8){ old_sw8 = sw8; if(sw8 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch9IsPressed(void)
{
	sw_scan(); 
	if(sw9 != old_sw9){ old_sw9 = sw9; if(sw9 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch10IsPressed(void)
{
	sw_scan(); 
	if(sw10 != old_sw10){ old_sw10 = sw10; if(sw10 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch11IsPressed(void)
{
	sw_scan(); 
	if(sw11 != old_sw11){ old_sw11 = sw11; if(sw11 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch12IsPressed(void)
{
	sw_scan(); 
	if(sw12 != old_sw12){ old_sw12 = sw1; if(sw12 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch13IsPressed(void)
{
	sw_scan(); 
	if(sw13 != old_sw13){ old_sw13 = sw13; if(sw13 == 1) return TRUE;}
	return FALSE;
}


BOOL Switch14IsPressed(void)
{
	sw_scan(); 
	if(sw14 != old_sw14){ old_sw14 = sw14; if(sw14 == 1) return TRUE;}
	return FALSE;
}


void USBCBSuspend(void)
{
}

void USBCBWakeFromSuspend(void)
{
}

void USBCB_SOF_Handler(void)
{
}

void USBCBErrorHandler(void)
{
}

void USBCBCheckOtherReq(void)
{
	USBCheckHIDRequest();
}

void USBCBStdSetDscHandler(void)
{
}

void USBCBInitEP(void)
{
	USBEnableEndpoint(HID_EP,USB_IN_ENABLED|USB_OUT_ENABLED|USB_HANDSHAKE_ENABLED|USB_DISALLOW_SETUP);
	lastOUTTransmission	= HIDRxPacket(HID_EP,(BYTE*)hid_report_out,1);
}

void USBCBSendResume(void)
{
	static WORD	delay_count;
	
	if(USBGetRemoteWakeupStatus() == TRUE) 
	{
		if(USBIsBusSuspended() == TRUE)
		{
			USBMaskInterrupts();
			
			USBCBWakeFromSuspend();
			USBSuspendControl =	0; 
			USBBusIsSuspended =	FALSE;
			delay_count	= 3600U;		
			do
			{
				delay_count--;
			}while(delay_count);
			USBResumeControl = 1;
			delay_count	= 1800U;
			do
			{
				delay_count--;
			}while(delay_count);
			USBResumeControl = 0;
			USBUnmaskInterrupts();
		}
	}
}

BOOL USER_USB_CALLBACK_EVENT_HANDLER(int event,	void *pdata, WORD size)
{
	switch(	event )
	{
		case EVENT_TRANSFER:
			//Add application specific callback	task or	callback function here if desired.
			break;
		case EVENT_SOF:
			USBCB_SOF_Handler();
			break;
		case EVENT_SUSPEND:
			USBCBSuspend();
			break;
		case EVENT_RESUME:
			USBCBWakeFromSuspend();
			break;
		case EVENT_CONFIGURED: 
			USBCBInitEP();
			break;
		case EVENT_SET_DESCRIPTOR:
			USBCBStdSetDscHandler();
			break;
		case EVENT_EP0_REQUEST:
			USBCBCheckOtherReq();
			break;
		case EVENT_BUS_ERROR:
			USBCBErrorHandler();
			break;
		case EVENT_TRANSFER_TERMINATED:
			break;
		default:
			break;
	}	   
	return TRUE; 
}

void USBHIDCBSetReportHandler(void)
{
	USBEP0Receive((BYTE*)CtrlTrfData, USB_EP0_BUFF_SIZE, USBHIDCBSetReportComplete);
}

void USBHIDCBSetReportComplete(void)
{
}	
